!!ARBvp1.0

ATTRIB iPos         = vertex.position;
ATTRIB iNormal      = vertex.normal;
ATTRIB iTanS        = vertex.attrib[1];
ATTRIB iTanT        = vertex.attrib[2];
ATTRIB iTexCoord0   = vertex.texcoord[0];
ATTRIB iTexCoord2   = vertex.texcoord[2];
ATTRIB iTexCoord3   = vertex.texcoord[3];

PARAM  mvp[4]       = { state.matrix.mvp };
PARAM  lightPos     = program.local[1];

OUTPUT oPos         = result.position;
OUTPUT oTexCoord0   = result.texcoord[0];
OUTPUT oTexCoord1   = result.texcoord[1];
OUTPUT oTexCoord2   = result.texcoord[2];
OUTPUT oTexCoord3   = result.texcoord[3];

# transform vertex position to clip coords
DP4 oPos.x, mvp[0], iPos;
DP4 oPos.y, mvp[1], iPos;
DP4 oPos.z, mvp[2], iPos;
DP4 oPos.w, mvp[3], iPos;

# transform light vector from object space to tangent space
DP3 oTexCoord1.x, iTanS,   lightPos;
DP3 oTexCoord1.y, iTanT,   lightPos;
DP3 oTexCoord1.z, iNormal, lightPos;

# pass on the other tex coords
MOV oTexCoord0, iTexCoord0;
MOV oTexCoord2, iTexCoord2;
MOV oTexCoord3, iTexCoord3;

END
